# Traceroute Internet Mapper - TIM

## Development

### Backend

Pre-requisites: `pipenv`, or whichever venv manager you prefer

```sh
# Install all dependencies. `pipenv` was used previously:
pipenv --python 3.11
pipenv install

# Start dev server
pipenv shell
fastapi dev app/main.py

# Start posting data to the tracing endpoint:
traceroute git.rauhala.info -q1 | http POST localhost:8000/trace/MYHOSTNAME
```

### Frontend

Pre-requisites: `nvm`, `tsc` / `typescript`

```sh
# Install latest npm version with node version manager:
nvm install 22

# Install project packages:
npm install

# Regular usage, activate project node version & start TS compiler in watch mode:
nvm use
tsc -w
```

## URLs of interest

- http://localhost:8000/
  - API Index, nothing to see.

- http://localhost:8000/docs/
  - Autogenerated API docs, mildy interesting

- http://localhost:8000/static/index.html
  - Rendered HTML index, very interesting
